<template>
  <div class="p-6 space-y-6">
    <div
      v-if="
        paymentWithdrawalTextInfo.Text &&
        !$route.fullPath.includes('internetbanking')
      "
      class="p-4 text-sm rounded bg-background5 --text4 font-normal mb-4"
    >
      <span v-html="paymentWithdrawalTextInfo?.Text"></span>
    </div>
    <h5 class="--text4">{{ $t("bank") }}</h5>
    <ui-radio-group
      v-model="selectedBank"
      class="grid grid-cols-3 gap-4 justify-items-stretch"
    >
      <ui-radio-button
        v-for="bank in bankRadios.radios"
        :key="bank.text"
        :label="bank.text"
        id="withdrawalBanks"
      >
        <ui-check-button
          :text="bank.text"
          variant="TEXT_ONLY"
          style="
            --height: 100%;
            --content-padding: 0 1rem;
            --border-radius: 0.5rem;
            min-height: 48px;
          "
        />
      </ui-radio-button>
    </ui-radio-group>
  </div>
  <div class="p-6">
    <el-form
      ref="ruleFormRef"
      :model="formData"
      status-icon
      :rules="getRule"
      label-width="210px"
      label-position="left"
      :validate-on-rule-change="false"
      class="cutomeClass"
    >
      <template v-if="isAupay">
        <el-form-item :label="$t('Pix Number')"
          prop="ExtraParameter.pixnumber"
          :rules="[
            {
              required: true,
              message: $t('required'),
              trigger: 'blur',
            },
          ]"
        >
          <el-input id="withdrawalPixNumber" v-model="formData.ExtraParameter.pixnumber"/>
        </el-form-item>
        <el-form-item :label="$t('Pix Type')"
          prop="ExtraParameter.pixtype"
          :rules="[
            {
              required: true,
              message: $t('required'),
              trigger: ['blur', 'change'],
            },
          ]"
        >
          <el-select v-model="formData.ExtraParameter.pixtype" class="w-full" placeholder="Select">
            <el-option
              v-for="item in pixTypeOptions"
              :key="item.value"
              :label="item.label"
              :value="item.value"
            />
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('name')"
          prop="ExtraParameter.name"
          :rules="[
            {
              required: true,
              message: $t('required'),
              trigger: 'blur',
            },
          ]"
        >
          <el-input id="withdrawalPixName" v-model="formData.ExtraParameter.name" />
        </el-form-item>
        <el-form-item :label="$t('CPF Number')"
          prop="ExtraParameter.cpfnumber"
          :rules="[
            {
              required: true,
              message: $t('required'),
              trigger: 'blur',
            },
          ]"
        >
          <el-input id="withdrawalCPFNumber" 
            v-model="formData.ExtraParameter.cpfnumber"
          />
        </el-form-item>
      </template>
      <template v-else>
        <el-form-item
          v-if="isGlobalPayJPY"
          :label="$t('Branch Code')"
          prop="ExtraParameter.branchcode"
          :rules="[
            {
              required: true,
              message: $t('required'),
              trigger: 'blur',
            },
            {
              pattern: /^\d{3}$/,
              message: $t('must_be_3_digits_number'),
              trigger: 'blur',
            },
          ]"
        >
          <el-input id="branchcode" 
            v-model="formData.ExtraParameter.branchcode"
            oninput="this.value = this.value.replace(/[^.0-9]/g, '')"
          />
        </el-form-item>
        <div v-if="isHiddenForSpecificBank()">
          <el-form-item :label="$t('bank_account_name')" prop="bankAccountName">
            <el-input id="withdrawalBankAccountName" :disabled="isFillInPaymentBank === true && getPlayerBank !== undefined" v-model="formData.bankAccountName" />
          </el-form-item>
          <el-form-item :label="$t('bank_account_number')" prop="bankAccountNumber">
            <el-input
              id="withdrawalBankAccountNumber"
              :disabled="isFillInPaymentBank === true && getPlayerBank !== undefined"
              v-model="formData.bankAccountNumber"
              @input="onInputValue($event, formData, 'bankAccountNumber')"
            />
          </el-form-item>
        </div>
      </template>
      <template v-if="isGtrpay">
        <el-form-item
          :label="$t('CPF Number')"
          prop="ExtraParameter.cpfnumber"
          :rules="[
            {
              required: true,
              message: $t('required'),
              trigger: 'blur',
            },
          ]"
        >
          <el-input id="withdrawalCPFNumber" 
            v-model="formData.ExtraParameter.cpfnumber"
          />
        </el-form-item>
      </template>
      <el-form-item :label="$t('balance')" prop="balance">
        {{ playerCreditBalance }}
      </el-form-item>
      <template v-if="isWithdrawalLimitEnabled">
        <el-form-item v-if="isAllowEligibleWithdrawal" :label="$t('eligible_withdrawal')">
          <div class="fc-primary font-bold">{{ eligibleWithdrawal }}</div>
        </el-form-item>
        <el-form-item prop="withdrawalLimit" :label="$t('remaining_rollover')">
          {{ remainingRollover }}
        </el-form-item>
      </template>
      <el-form-item :label="$t('amount')" prop="amountValue">
        <el-input
          id="withdrawalAmount"
          v-model="formData.amountValue"
          @input="onInputValue($event, formData, 'amountValue')"
          :placeholder="amountPlaceholder"
        >
          <template v-if="checkedCurrency" #append>
            <span>000</span>
          </template>
        </el-input>
        <span
          v-if="checkedCurrency"
          class="order-1 mt-3 text-xs fc-hint font-normal"
          >{{
            $t(
              `withdrawal_amount_shown_by_the_system_${profile.Currency.toLowerCase()}`
            )
          }}</span
        >
      </el-form-item>
      <el-form-item
        v-if="isPaymentPasswordEnable"
        :label="$t('payment_password')"
        prop="paymentPassword"
      >
        <el-input v-model="formData.paymentPassword" type="password" id="withdrawalPaymentPassword"></el-input>
      </el-form-item>
      <el-form-item>
        <div
          v-if="
            internetBankingWithdrawalTextInfo?.Text &&
            $route.fullPath.includes('internetbanking')
          "
          class="w-full p-4 bg-background5"
        >
          <span v-html="internetBankingWithdrawalTextInfo?.Text"></span>
        </div>
      </el-form-item>
      <el-form-item>
        <div class="text-center">
          <el-button
            type="primary"
            round
            :disabled="isWithdrawProcessing"
            @click="submitWithdrawal(ruleFormRef)"
            >{{ $t("continue") }}</el-button
          >
        </div>
      </el-form-item>
    </el-form>
  </div>
</template>
<script lang="ts">
import { defineComponent, PropType, toRefs, ref } from "vue";
import { IGetPaymentGatewayBanksResponse } from "@/models/getPaymentGatewayBanksRespone";
import { ProfileDto } from "@/models/getProfileResponse";
import { usePaymentBankTransferWithdrawal } from "@/composables/payment/withdrawal/usePaymentBankTransferWithdrawal";
import { inputEmits } from "element-plus";

export default defineComponent({
  props: {
    paymentBanks: {
      type: Object as PropType<IGetPaymentGatewayBanksResponse>,
      required: true,
    },
    profile: {
      type: Object as PropType<ProfileDto>,
      required: true,
    },
    isPaymentPasswordEnable: {
      type: Boolean,
      default: false,
    },
    isWithdrawalLimitEnabled: {
      type: Boolean,
      default: false,
    },
  },
  setup(props) {
    const {
      paymentBanks,
      profile,
      isPaymentPasswordEnable,
      isWithdrawalLimitEnabled,
    } = toRefs(props);
    const {
      bankRadios,
      playerCreditBalance,
      selectedBank,
      withdrawalMin,
      withdrawalMax,
      submitWithdrawal,
      getRule,
      formData,
      ruleFormRef,
      isWithdrawProcessing,
      checkedCurrency,
      remainingRollover,
      eligibleWithdrawal,
      isDecimalAllow,
      amountPlaceholder,
      internetBankingWithdrawalTextInfo,
      paymentWithdrawalTextInfo,
      isFillInPaymentBank,
      getPlayerBank,
      pixTypeOptions,
      isAupay,
      isGtrpay,
      isGlobalPayJPY,
      isHiddenForSpecificBank,
    } = usePaymentBankTransferWithdrawal(
      paymentBanks,
      profile,
      isPaymentPasswordEnable,
      isWithdrawalLimitEnabled
    );
    const { getAssetImage, onInputValue, allowCompany, isAllowEligibleWithdrawal } = commonHelper;

    return {
      bankRadios,
      playerCreditBalance,
      selectedBank,
      withdrawalMin,
      withdrawalMax,
      submitWithdrawal,
      getRule,
      formData,
      ruleFormRef,
      isWithdrawProcessing,
      checkedCurrency,
      remainingRollover,
      eligibleWithdrawal,
      isDecimalAllow,
      amountPlaceholder,
      internetBankingWithdrawalTextInfo,
      getAssetImage,
      paymentWithdrawalTextInfo,
      isFillInPaymentBank,
      getPlayerBank,
      pixTypeOptions,
      isAupay,
      onInputValue,
      allowCompany,
      isGtrpay,
      isAllowEligibleWithdrawal,
      isGlobalPayJPY,
      isHiddenForSpecificBank,
    };
  },
});
</script>
